From ae164d39e30fb03e7f6d5b61264a3e67adeae448 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Fri, 10 Aug 2018 13:58:14 -0400
Subject: [PATCH 12/17] FIXME: more WIP on diagnostic_group

---
 gcc/attribs.c                  |  33 ++--
 gcc/c-family/c-attribs.c       |  14 +-
 gcc/c-family/c-opts.c          |  13 +-
 gcc/c-family/c-warn.c          |  27 +--
 gcc/c-family/known-headers.cc  |  14 +-
 gcc/c-family/known-headers.h   |   4 +-
 gcc/c-family/name-hint.h       |   8 +-
 gcc/c/c-decl.c                 | 371 ++++++++++++++++++++----------------
 gcc/c/c-parser.c               |  42 +++--
 gcc/c/c-typeck.c               | 168 ++++++++++-------
 gcc/calls.c                    |  42 +++--
 gcc/cgraphunit.c               |  30 +--
 gcc/cp/call.c                  | 418 +++++++++++++++++++++++------------------
 gcc/cp/class.c                 | 180 ++++++++++--------
 gcc/cp/constexpr.c             |  59 +++---
 gcc/cp/constraint.cc           |   6 +-
 gcc/cp/cp-gimplify.c           |  15 +-
 gcc/cp/cp-tree.h               |  11 +-
 gcc/cp/cvt.c                   |  35 ++--
 gcc/cp/decl.c                  | 161 +++++++++-------
 gcc/cp/decl2.c                 |  50 ++---
 gcc/cp/error.c                 |  12 +-
 gcc/cp/friend.c                |  40 ++--
 gcc/cp/init.c                  |  83 ++++----
 gcc/cp/lex.c                   |   5 +-
 gcc/cp/name-lookup.c           | 166 ++++++++--------
 gcc/cp/parser.c                | 106 ++++++-----
 gcc/cp/pt.c                    |  86 +++++----
 gcc/cp/search.c                |  74 ++++----
 gcc/cp/tree.c                  |  22 ++-
 gcc/cp/typeck.c                | 100 +++++-----
 gcc/cp/typeck2.c               |  65 ++++---
 gcc/diagnostic-core.h          |  37 +++-
 gcc/diagnostic.c               | 319 ++++++++++++++++++++++++-------
 gcc/gimple-ssa-isolate-paths.c |  45 +++--
 gcc/gimple-ssa-warn-alloca.c   |  50 ++---
 gcc/gimple-ssa-warn-restrict.c |  54 +++---
 gcc/gimplify.c                 |  27 +--
 gcc/hsa-gen.c                  |  10 +-
 gcc/ipa-devirt.c               | 196 ++++++++++---------
 gcc/multiple_target.c          |   7 +-
 gcc/opts-common.c              |   9 +-
 gcc/reginfo.c                  |  12 +-
 gcc/substring-locations.c      |   6 +-
 gcc/tree-inline.c              |  11 +-
 gcc/tree-ssa-ccp.c             |  17 +-
 gcc/tree-ssa-loop-niter.c      |   7 +-
 gcc/tree-ssa-uninit.c          |   5 +-
 gcc/tree.c                     |  30 +--
 49 files changed, 1931 insertions(+), 1371 deletions(-)

diff --git a/gcc/attribs.c b/gcc/attribs.c
index efc879b..09c9ceb 100644
--- a/gcc/attribs.c
+++ b/gcc/attribs.c
@@ -430,23 +430,23 @@ diag_attr_exclusions (tree last_decl, tree node, tree attrname,
 
 	  /* Print a note?  */
 	  bool note = last_decl != NULL_TREE;
-
+	  diagnostic_group d;
 	  if (TREE_CODE (node) == FUNCTION_DECL
 	      && DECL_BUILT_IN (node))
-	    note &= warning (OPT_Wattributes,
-			     "ignoring attribute %qE in declaration of "
-			     "a built-in function %qD because it conflicts "
-			     "with attribute %qs",
-			     attrname, node, excl->name);
+	    note &= d.warning (OPT_Wattributes,
+			       "ignoring attribute %qE in declaration of "
+			       "a built-in function %qD because it conflicts "
+			       "with attribute %qs",
+			       attrname, node, excl->name);
 	  else
-	    note &= warning (OPT_Wattributes,
-			     "ignoring attribute %qE because "
-			     "it conflicts with attribute %qs",
-			     attrname, excl->name);
+	    note &= d.warning (OPT_Wattributes,
+			       "ignoring attribute %qE because "
+			       "it conflicts with attribute %qs",
+			       attrname, excl->name);
 
 	  if (note)
-	    inform (DECL_SOURCE_LOCATION (last_decl),
-		    "previous declaration here");
+	    d.inform (DECL_SOURCE_LOCATION (last_decl),
+		      "previous declaration here");
 	}
     }
 
@@ -587,10 +587,11 @@ decl_attributes (tree *node, tree attributes, int flags,
 	  /* This is a c++11 attribute that appertains to a
 	     type-specifier, outside of the definition of, a class
 	     type.  Ignore it.  */
-	  if (warning (OPT_Wattributes, "attribute ignored"))
-	    inform (input_location,
-		    "an attribute that appertains to a type-specifier "
-		    "is ignored");
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wattributes, "attribute ignored"))
+	    d.inform (input_location,
+		      "an attribute that appertains to a type-specifier "
+		      "is ignored");
 	  continue;
 	}
 
diff --git a/gcc/c-family/c-attribs.c b/gcc/c-family/c-attribs.c
index 9da9c27..1f1ec16 100644
--- a/gcc/c-family/c-attribs.c
+++ b/gcc/c-family/c-attribs.c
@@ -1881,17 +1881,19 @@ common_handle_aligned_attribute (tree *node, tree name, tree args, int flags,
       bitalign /= BITS_PER_UNIT;
 
       bool diagd = true;
+      diagnostic_group d;
       if (DECL_USER_ALIGN (decl) || DECL_USER_ALIGN (last_decl))
-	diagd = warning (OPT_Wattributes,
-			  "ignoring attribute %<%E (%u)%> because it conflicts "
-			  "with attribute %<%E (%u)%>",
-			  name, bitalign, name, curalign);
+	diagd = d.warning (OPT_Wattributes,
+			   "ignoring attribute %<%E (%u)%> because it "
+			   "conflicts with attribute %<%E (%u)%>",
+			   name, bitalign, name, curalign);
       else if (!warn_if_not_aligned_p)
 	/* Do not error out for attribute warn_if_not_aligned.  */
-	error ("alignment for %q+D must be at least %d", decl, curalign);
+	d.error ("alignment for %q+D must be at least %d", decl, curalign);
 
       if (diagd && note)
-	inform (DECL_SOURCE_LOCATION (last_decl), "previous declaration here");
+	d.inform (DECL_SOURCE_LOCATION (last_decl),
+		  "previous declaration here");
 
       *no_add_attrs = true;
     }
diff --git a/gcc/c-family/c-opts.c b/gcc/c-family/c-opts.c
index cb69fb3..532fec9 100644
--- a/gcc/c-family/c-opts.c
+++ b/gcc/c-family/c-opts.c
@@ -931,13 +931,14 @@ c_common_post_options (const char **pfilename)
       warn_abi_version = latest_abi_version;
       if (flag_abi_version == latest_abi_version)
 	{
-	  if (warning (OPT_Wabi, "-Wabi won't warn about anything"))
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wabi, "-Wabi won't warn about anything"))
 	    {
-	      inform (input_location, "-Wabi warns about differences "
-		      "from the most up-to-date ABI, which is also used "
-		      "by default");
-	      inform (input_location, "use e.g. -Wabi=11 to warn about "
-		      "changes from GCC 7");
+	      d.inform (input_location, "-Wabi warns about differences "
+			"from the most up-to-date ABI, which is also used "
+			"by default");
+	      d.inform (input_location, "use e.g. -Wabi=11 to warn about "
+			"changes from GCC 7");
 	    }
 	  flag_abi_compat_version = abi_compat_default;
 	}
diff --git a/gcc/c-family/c-warn.c b/gcc/c-family/c-warn.c
index d34d667..33a4516 100644
--- a/gcc/c-family/c-warn.c
+++ b/gcc/c-family/c-warn.c
@@ -491,17 +491,18 @@ warn_logical_not_parentheses (location_t location, enum tree_code code,
       && integer_zerop (rhs))
     return;
 
-  if (warning_at (location, OPT_Wlogical_not_parentheses,
-		  "logical not is only applied to the left hand side of "
-		  "comparison")
+  diagnostic_group d;
+  if (d.warning_at (location, OPT_Wlogical_not_parentheses,
+		    "logical not is only applied to the left hand side of "
+		    "comparison")
       && EXPR_HAS_LOCATION (lhs))
     {
       location_t lhs_loc = EXPR_LOCATION (lhs);
       rich_location richloc (line_table, lhs_loc);
       richloc.add_fixit_insert_before (lhs_loc, "(");
       richloc.add_fixit_insert_after (lhs_loc, ")");
-      inform (&richloc, "add parentheses around left hand side "
-	      "expression to silence this warning");
+      d.inform (&richloc, "add parentheses around left hand side "
+		"expression to silence this warning");
     }
 }
 
@@ -2232,9 +2233,10 @@ warn_duplicated_cond_add_or_warn (location_t loc, tree cond, vec<tree> **chain)
   FOR_EACH_VEC_ELT (**chain, ix, t)
     if (operand_equal_p (cond, t, 0))
       {
-	if (warning_at (loc, OPT_Wduplicated_cond,
-			"duplicated %<if%> condition"))
-	  inform (EXPR_LOCATION (t), "previously used here");
+	diagnostic_group d;
+	if (d.warning_at (loc, OPT_Wduplicated_cond,
+			  "duplicated %<if%> condition"))
+	  d.inform (EXPR_LOCATION (t), "previously used here");
 	found = true;
 	break;
       }
@@ -2601,8 +2603,9 @@ warn_for_multistatement_macros (location_t body_loc, location_t next_loc,
 	return;
     }
 
-  if (warning_at (body_loc, OPT_Wmultistatement_macros,
-		  "macro expands to multiple statements"))
-    inform (guard_loc, "some parts of macro expansion are not guarded by "
-	    "this %qs clause", guard_tinfo_to_string (keyword));
+  diagnostic_group d;
+  if (d.warning_at (body_loc, OPT_Wmultistatement_macros,
+		    "macro expands to multiple statements"))
+    d.inform (guard_loc, "some parts of macro expansion are not guarded by "
+	      "this %qs clause", guard_tinfo_to_string (keyword));
 }
diff --git a/gcc/c-family/known-headers.cc b/gcc/c-family/known-headers.cc
index 5524d21..8dff491 100644
--- a/gcc/c-family/known-headers.cc
+++ b/gcc/c-family/known-headers.cc
@@ -175,10 +175,12 @@ get_cp_stdlib_header_for_name (const char *name)
 
 /* suggest_missing_header's ctor.  */
 
-suggest_missing_header::suggest_missing_header (location_t loc,
+suggest_missing_header::suggest_missing_header (diagnostic_group *group,
+						location_t loc,
 						const char *name,
 						const char *header_hint)
-: deferred_diagnostic (loc), m_name_str (name), m_header_hint (header_hint)
+: deferred_diagnostic (group, loc),
+  m_name_str (name), m_header_hint (header_hint)
 {
   gcc_assert (name);
   gcc_assert (header_hint);
@@ -193,8 +195,8 @@ suggest_missing_header::~suggest_missing_header ()
 
   gcc_rich_location richloc (get_location ());
   maybe_add_include_fixit (&richloc, m_header_hint);
-  inform (&richloc,
-	  "%qs is defined in header %qs;"
-	  " did you forget to %<#include %s%>?",
-	  m_name_str, m_header_hint, m_header_hint);
+  get_group ()->inform (&richloc,
+			"%qs is defined in header %qs;"
+			" did you forget to %<#include %s%>?",
+			m_name_str, m_header_hint, m_header_hint);
 }
diff --git a/gcc/c-family/known-headers.h b/gcc/c-family/known-headers.h
index 3a68ad2..941e532 100644
--- a/gcc/c-family/known-headers.h
+++ b/gcc/c-family/known-headers.h
@@ -29,8 +29,8 @@ extern const char *get_cp_stdlib_header_for_name (const char *name);
 class suggest_missing_header : public deferred_diagnostic
 {
  public:
-  suggest_missing_header (location_t loc, const char *name,
-			  const char *header_hint);
+  suggest_missing_header (diagnostic_group *group, location_t,
+			  const char *name, const char *header_hint);
   ~suggest_missing_header ();
 
  private:
diff --git a/gcc/c-family/name-hint.h b/gcc/c-family/name-hint.h
index ef0e4a3..5b28a82 100644
--- a/gcc/c-family/name-hint.h
+++ b/gcc/c-family/name-hint.h
@@ -50,6 +50,7 @@ class deferred_diagnostic
  public:
   virtual ~deferred_diagnostic () {}
 
+  diagnostic_group *get_group () const { return m_group; }
   location_t get_location () const { return m_loc; }
 
   /* Call this if the corresponding warning was not emitted,
@@ -62,10 +63,11 @@ class deferred_diagnostic
   bool is_suppressed_p () const { return m_suppress; }
 
  protected:
-  deferred_diagnostic (location_t loc)
-  : m_loc (loc), m_suppress (false) {}
+  deferred_diagnostic (diagnostic_group *group, location_t loc)
+  : m_group (group), m_loc (loc), m_suppress (false) {}
 
  private:
+  diagnostic_group *m_group;
   location_t m_loc;
   bool m_suppress;
 };
@@ -116,6 +118,6 @@ private:
 };
 
 extern name_hint lookup_name_fuzzy (tree, enum lookup_name_fuzzy_kind,
-				    location_t);
+				    diagnostic_group *, location_t);
 
 #endif /* ! GCC_NAME_HINT_H */
